/****************************************************************************/
/* Dagda specific functions.                                                */
/*                                                                          */
/*  Author(s):                                                              */
/*    - Gael Le Mahec (lemahec@in2p3.fr)                                    */
/*                                                                          */
/*  This file is part of DIET .                                             */
/*                                                                          */
/*  Copyright ENS Lyon, INRIA, UCBL, SysFera (2000)                         */
/*                                                                          */
/*  - Frederic.Desprez@ens-lyon.fr (Project Manager)                        */
/*  - Eddy.Caron@ens-lyon.fr (Technical Manager)                            */
/*  - Tech@sysfera.com (Maintainer and Technical Support)                   */
/*                                                                          */
/*  This software is a computer program whose purpose is to provide an      */
/*  easy and transparent access to distributed and heterogeneous            */
/*  platforms.                                                              */
/*                                                                          */
/*                                                                          */
/*  This software is governed by the CeCILL license under French law and    */
/*  abiding by the rules of distribution of free software.  You can  use,   */
/*  modify and/ or redistribute the software under the terms of the CeCILL  */
/*  license as circulated by CEA, CNRS and INRIA at the following URL       */
/*  "http://www.cecill.info".                                               */
/*                                                                          */
/*  As a counterpart to the access to the source code and  rights to copy,  */
/*  modify and redistribute granted by the license, users are provided      */
/*  only with a limited warranty  and the software's author,  the holder    */
/*  of the economic rights,  and the successive licensors  have only        */
/*  limited liability.                                                      */
/*                                                                          */
/*  In this respect, the user's attention is drawn to the risks             */
/*  associated with loading,  using,  modifying and/or developing or        */
/*  reproducing the software by the user in light of its specific status    */
/*  of free software, that may mean  that it is complicated to              */
/*  manipulate, and  that  also therefore means  that it is reserved for    */
/*  developers and experienced professionals having in-depth computer       */
/*  knowledge. Users are therefore encouraged to load and test the          */
/*  software's suitability as regards their requirements in conditions      */
/*  enabling the security of their systems and/or data to be ensured and,   */
/*  more generally, to use and operate it in the same conditions as         */
/*  regards security.                                                       */
/*                                                                          */
/*  The fact that you are presently reading this means that you have had    */
/*  knowledge of the CeCILL license and that you accept its terms.          */
/*                                                                          */
/****************************************************************************/
/* $Id$
 * $Log$
 * Revision 1.4  2008/11/07 14:22:40  bdepardo
 * Headers correction.
 * Initialize maxMemSpace to 0 by default.
 * removed some warnings due to a return type of 'const size_t' -> const is
 * useless
 *
 * Revision 1.3  2008/08/13 10:12:21  ecaron
 * Correction of the header file
 *
 ****************************************************************************/

#ifndef __DIET_DAGDA_HH__
#define __DIET_DAGDA_HH__

#include "DIET_data.h"
#include "MasterAgentImpl.hh"
#include "debug.hh"
#include "DIET_grpc.h"


/* Client side. */
void dagda_mrsh_profile(corba_profile_t*, diet_profile_t*, MasterAgent_var&);
void dagda_download_SeD_data(diet_profile_t*, corba_profile_t*);
diet_error_t dagda_get_data_desc(corba_pb_desc_t&, MasterAgent_var&);

/* Server side. */
void dagda_download_data(diet_profile_t&, corba_profile_t&);
void dagda_upload_data(diet_profile_t& profile, corba_profile_t& pb);
//void dagda_free_volatile_data(corba_profile_t* pb);
#endif
