/****************************************************************************/
/* DIET Fault Detector pthreads->omni_thread mapping                        */
/*                                                                          */
/*  Author(s):                                                              */
/*    - Aurlien Bouteiller (aurelien.bouteiller@inria.fr)                  */
/*  This file is part of DIET .                                             */
/*                                                                          */
/*  Copyright ENS Lyon, INRIA, UCBL, SysFera (2000)                         */
/*                                                                          */
/*  - Frederic.Desprez@ens-lyon.fr (Project Manager)                        */
/*  - Eddy.Caron@ens-lyon.fr (Technical Manager)                            */
/*  - Tech@sysfera.com (Maintainer and Technical Support)                   */
/*                                                                          */
/*  This software is a computer program whose purpose is to provide an      */
/*  easy and transparent access to distributed and heterogeneous            */
/*  platforms.                                                              */
/*                                                                          */
/*                                                                          */
/*  This software is governed by the CeCILL license under French law and    */
/*  abiding by the rules of distribution of free software.  You can  use,   */
/*  modify and/ or redistribute the software under the terms of the CeCILL  */
/*  license as circulated by CEA, CNRS and INRIA at the following URL       */
/*  "http://www.cecill.info".                                               */
/*                                                                          */
/*  As a counterpart to the access to the source code and  rights to copy,  */
/*  modify and redistribute granted by the license, users are provided      */
/*  only with a limited warranty  and the software's author,  the holder    */
/*  of the economic rights,  and the successive licensors  have only        */
/*  limited liability.                                                      */
/*                                                                          */
/*  In this respect, the user's attention is drawn to the risks             */
/*  associated with loading,  using,  modifying and/or developing or        */
/*  reproducing the software by the user in light of its specific status    */
/*  of free software, that may mean  that it is complicated to              */
/*  manipulate, and  that  also therefore means  that it is reserved for    */
/*  developers and experienced professionals having in-depth computer       */
/*  knowledge. Users are therefore encouraged to load and test the          */
/*  software's suitability as regards their requirements in conditions      */
/*  enabling the security of their systems and/or data to be ensured and,   */
/*  more generally, to use and operate it in the same conditions as         */
/*  regards security.                                                       */
/*                                                                          */
/*  The fact that you are presently reading this means that you have had    */
/*  knowledge of the CeCILL license and that you accept its terms.          */
/*                                                                          */
/****************************************************************************/
/* $Id$ 
 * $Log$
 * Revision 1.4  2006/11/07 00:37:44  ecaron
 * Bug fix for MacOSX support
 *
 * Revision 1.3  2006/06/20 13:29:16  abouteil
 *
 *
 * Chandra&Toueg&Aguilera fault detector implementation.
 *
 * A
 *
 ****************************************************************************/
#ifndef __INCLUDE_THREADOVERLAY__
#define __INCLUDE_THREADOVERLAY__
#include "omniORB4/CORBA.h"
#include <omnithread.h>

typedef omni_thread *thread_t;
#define thread_create(id, attr, fn, arg) (!((*(id)) = omni_thread::create(fn, arg)))
#define thread_join(id, ret) ((id)->join(ret))
#define thread_detach(id) 0

typedef omni_mutex *thread_mutex_t;
#define THREAD_MUTEX_INITIALIZER (new omni_mutex())
#define thread_mutex_lock(id) ((*(id))->lock())
#define thread_mutex_unlock(id) ((*(id))->unlock())

typedef omni_condition *thread_cond_t;
#define THREAD_COND_INITIALIZER NULL
#define thread_cond_wait(id, m) ((*(id)) ? (*(id))->wait() : ((*(id)) = new omni_condition(*m))->wait())
#define thread_cond_timedwait(id, m, ts) ((*(id)) ? (*(id))->timedwait((ts)->tv_sec, (ts)->tv_nsec) : ((*(id)) = new omni_condition(*(m)))->timedwait((ts)->tv_sec, (ts)->tv_nsec))
#define thread_cond_signal(id) ((*(id))->signal())
#define thread_cond_boadcast(id) ((*(id))->broadcast())

#endif
